﻿# Funktionen-als-Parameter.py

# Als Beispielanwendung dient eine Sortierfunktion
# Parameter ist die Ordnungsfunktion

def sortiereEin(element, liste, praedikat):
    if liste==[]: return [element]
    # sonst einfügen:
    for index in range(len(liste)):
        if praedikat(element, liste[index]):
            liste[index:index]=[element]
            return liste
    # sonst am Schluss anhängen:
    liste[len(liste):len(liste)]=[element]
    return liste

def sortiere(liste, praedikat):
    if liste==[]: return liste
    sortiert=[liste[0]]
    for element in liste[1:]:
        sortiert=sortiereEin(element, sortiert, praedikat)
    return sortiert

# Grundbeispiel:
def kleiner(a, b):
    return a < b
ergebnis = sortiere([34,988,236457,35,746,256,82,3,23423,23,452,3,1], kleiner)
print( ergebnis )

# Mit "Vektoren" (x,y,z)
# Das ist nun aber "richtig" funktional!
def kleiner(a, b):
    return sum(map(lambda w:w*w, a)) < sum(map(lambda w:w*w, b))
ergebnis = sortiere([(1,1,1), (0,0,0), (1,2,3), (-2,0,-1)], kleiner)
print( ergebnis )
